<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Admin extends CI_Controller {

	/**
	 * Index Page for this controller.
	 *
	 * Maps to the following URL
	 * 		http://example.com/index.php/welcome
	 *	- or -
	 * 		http://example.com/index.php/welcome/index
	 *	- or -
	 * Since this controller is set as the default controller in
	 * config/routes.php, it's displayed at http://example.com/
	 *
	 * So any other public methods not prefixed with an underscore will
	 * map to /index.php/welcome/<method_name>
	 * @see https://codeigniter.com/user_guide/general/urls.html
	 */
	 
	/* Below function is for login page */ 
	 
	public function index() 
	{
		$this->load->library('session');
		
		if($this->input->post()) {
			$this->load->library('form_validation');
			$this->form_validation->set_rules('name', 'Username', 'trim|required');
			$this->form_validation->set_rules('pass', 'Password', 'trim|required');
			if ($this->form_validation->run() == FALSE) 
			{
				$data = array(
                    'name' => 'Enter Username',
                    'pass' => 'Enter Password'
                );
                $this->load->view('login', $data);
			}
			else 
			{
				$data = array(
					'name' => $this->input->post('name'),
					'pass' => $this->input->post('pass')
				);
				$this->load->model('login_model');
				$result = $this->login_model->login($data);
				if($result != false) {
					$this->session->set_userdata('ADMIN_SESS_USERID', $result[0]->id);
					redirect('Admin/deskboard');
				} else {
					redirect('?pas=1');
				}
			}
		} else {		
			if(!$this->session->userdata('ADMIN_SESS_USERID')) {
				$this->load->view('login');
			} else {
				redirect('Admin/deskboard');
			}
		}
	}
	
	/* Below function has used for deskboard data */
	
	public function deskboard() {
		if(!$this->session->userdata('ADMIN_SESS_USERID')) {
			redirect('');
		}
		$this->load->model('deskboard_model');
		$category_count = $this->deskboard_model->category_count();
		$question_count = $this->deskboard_model->question_count();
		$user_count = $this->deskboard_model->user_count();
		$data = array(
			'category_count' => $category_count,
			'question_count' => $question_count,
			'user_count' => $user_count
		);
		$this->load->view('deskboard', $data);
	}
	
	/* Below functions has used for logout from the system. */ 
	
	public function logout() {
		$this->load->library('session');
		$this->session->unset_userdata('ADMIN_SESS_USERID');
		$this->session->sess_destroy();
		redirect('');
	}
	
	/* Below function has used for managing category listing page */ 
	
	public function manage_category() {
		if(!$this->session->userdata('ADMIN_SESS_USERID')) {
			redirect('');
		}
		$this->load->model('category_model');
		
		$category_array = $this->category_model->category_list();
		
		$data = array(
			'category_array' => $category_array,
		);
		$this->load->view('manage_category', $data);
	}
	
	/* Below function has used for managing users listing page */
	
	public function manage_users() 
	{
		if(!$this->session->userdata('ADMIN_SESS_USERID')) 
		{
			redirect('');
		}
		
		$this->load->model('user_model');
		
		$users_array = $this->user_model->user_list();
		
		$data = array(
			'users_array' => $users_array,
		);
		$this->load->view('manage_user', $data);
	}
	
	/* Below function has used for managing questions listing page */
	
	public function manage_question() 
	{
		if(!$this->session->userdata('ADMIN_SESS_USERID')) 
		{
			redirect('');
		}
		
		$this->load->model('questions_model');
		
		$questions_array = $this->questions_model->questions_list();
		
		$data = array(
			'questions_array' => $questions_array,
		);
		$this->load->view('manage_question', $data);
	}
	
	/* Below function has used for adding and editing questions category */
	
	public function add_category() 
	{
		if(!$this->session->userdata('ADMIN_SESS_USERID')) 
		{
			redirect('');
		}
		
		if(isset($_REQUEST['mode']))
		{
			if($_REQUEST['mode'] == 'edit' && isset($_REQUEST['id']) && $_REQUEST['id'] != "")
			{
				$id = $_REQUEST['id'];
				
				$this->load->model('category_model');
			
				$category_details = $this->category_model->get_category($id);	
				
				$category_details_data = array(
					'category_details' => $category_details,
				);
				
				$this->load->view('add_category',$category_details_data);
			}
			else
			{
				$this->load->view('add_category');
			}
		}
		
		if($this->input->post()) 
		{
			$this->load->library('form_validation');
			
			$this->form_validation->set_rules('category', 'Category', 'trim|required');
			
			if($_REQUEST['mode'] != 'edit')
			{
				if (empty($_FILES['image']['name']))
				{
					$this->form_validation->set_rules('image', 'Document', 'required');
				}	
			}
			
			if ($this->form_validation->run() == FALSE) 
			{
				$data = array(
                    'category' => 'category',
                    'image' => 'image',
					'filepath' => 'filepath',
					'error_message' => 'Fields are required'
                );
                $this->load->view('add_category?mode=add',$data);
			}
			else 
			{	
				if($_REQUEST['mode'] != 'edit')
				{
					$data = array(
						'category' => $this->input->post('category')
					);
					
					$this->load->model('addcategory_model');
					
					$result = $this->addcategory_model->insert_category($data);
					
					if($result != false) 
					{
						redirect('Admin/manage_category?msg=2');
					}
					else 
					{
						redirect('Admin/add_category?mode=add&msg=4');
					}		
				}
				else
				{
					$data = array(
						'category' => $this->input->post('category'),
						'id' => $this->input->post('id')
					);
					
					$id = $_REQUEST['id'];
					
					$this->load->model('addcategory_model');
					
					$result = $this->addcategory_model->update_category($data);
					
					if($result != false) 
					{
						redirect('Admin/manage_category?msg=2');
					}
					else 
					{
						redirect('Admin/add_category?id='.$id.'&mode=edit&msg=4');
					}
				}
			}
		} 
	}
	
	/* Below function has used for adding and editing questions */
	
	public function add_question() 
	{
		if(!$this->session->userdata('ADMIN_SESS_USERID')) 
		{
			redirect('');
		}
		
		$this->load->model('category_model');
		
		$category_array = $this->category_model->category_list();
		
		$category_list = array(
			'category_array' => $category_array,
		);
		
		if(isset($_REQUEST['mode']))
		{
			if($_REQUEST['mode'] == 'edit' && isset($_REQUEST['id']) && $_REQUEST['id'] != "")
			{
				$id = $_REQUEST['id'];
				
				$this->load->model('questions_model');
			
				$question_details = $this->questions_model->get_question($id);	
				
				$question_details_data = array(
					'category_array' => $category_array,
					'question_details' => $question_details
				);
				
				$this->load->view('add_question',$question_details_data);
			}
			else
			{
				$this->load->view('add_question',$category_list);
			}
		}
		
		if($this->input->post()) 
		{
			$this->load->library('form_validation');
			
			$this->form_validation->set_rules('category', 'Category', 'trim|required');
			$this->form_validation->set_rules('question', 'Question', 'trim|required');
			$this->form_validation->set_rules('answer', 'Answer', 'trim|required');
			
			if ($this->form_validation->run() == FALSE) 
			{
				$data = array(
                    'category' => 'category',
                    'question' => 'question',
					'Answer' => 'Answer',
					'error_message' => 'Fields are required'
                );
				
                $this->load->view('add_question',$data);
			}
			else 
			{
				$data = array(
					'id' => $this->input->post('id'),
					'category_id' => $this->input->post('category'),
					'question' => $this->input->post('question'),
					'ans' => $this->input->post('answer')
					);
				
				if($_REQUEST['mode'] != 'edit')
				{
					$this->load->model('addquestion_model');
					
					$result = $this->addquestion_model->insert_question($data);
					
					if($result != false) 
					{
						redirect('Admin/manage_question?msg=1');
					}
					else 
					{
						redirect('Admin/add_question?mode=add&msg=4');
					}	
				}
				else
				{
					$this->load->model('addquestion_model');
					
					$result = $this->addquestion_model->update_question($data);
					
					if($result != false) 
					{
						redirect('Admin/manage_question?msg=2');
					}
					else 
					{
						redirect('Admin/add_question?mode=add&msg=4');
					}	
				}
			}
		} 
	}
	
	/* Below function has used for editing users details */
	
	public function add_user() 
	{
		if(!$this->session->userdata('ADMIN_SESS_USERID')) 
		{
			redirect('');
		}
		
		$id = $_REQUEST['id'];
		
		$this->load->model('user_model');
	
		$user_detail = $this->user_model->get_user_details($id);	
		
		$user_data = array(
			'user_details' => $user_detail
		);
		
		$this->load->view('add_user',$user_data);
		
		if($this->input->post()) 
		{
			$this->load->library('form_validation');
			
			$this->form_validation->set_rules('name', 'Username', 'trim|required');
			
			if($_REQUEST['mode'] != 'edit')
			{
				if (empty($_FILES['image']['name']))
				{
					$this->form_validation->set_rules('image', 'Document', 'required');
				}
				if (empty($_FILES['images']['name']))
				{
					$this->form_validation->set_rules('images', 'Document', 'required');
				}				
			}
			
			if ($this->form_validation->run() == FALSE) 
			{
				$data = array(
                    'name' => 'Username',
                    'image' => 'Document',
					'images' => 'Document',
					'error_message' => 'Fields are required'
                );
                $this->load->view('add_category?mode=add',$data);
			}
			else 
			{
				$id = $_REQUEST['id'];
				
				$data = array(
					'id' => $this->input->post('id'),
					'name' => $this->input->post('name'),
					'deviceid' => $this->input->post('deviceid'),
				);
				
				$this->load->model('adduser_model');
				
				$result = $this->adduser_model->update_user($data);
				
				if($result != false) 
				{
					redirect('Admin/manage_users?msg=2');
				}
				else 
				{
					redirect('Admin/add_user?id='.$id.'&mode=edit&msg=4');
				}	
				
			}
		} 
	}
	
	/* Below function has used for importing question for particular category */
	
	public function import_question() 
	{
		if(!$this->session->userdata('ADMIN_SESS_USERID')) 
		{
			redirect('');
		}
		
		$this->load->model('category_model');
		
		$category_array = $this->category_model->category_list();
		
		$category_list = array(
			'category_array' => $category_array,
		);
		
		$this->load->view('import_question',$category_list);
		
		if($this->input->post()) 
		{
			$this->load->library('form_validation');
			
			$this->form_validation->set_rules('category', 'Category', 'trim|required');
			
			if (empty($_FILES['filepath']['name']))
			{
				$this->form_validation->set_rules('filepath', 'Document', 'required');
			}
			
			if ($this->form_validation->run() == FALSE) 
			{
				$data = array(
                    'category' => 'Category',
                    'filepath' => 'Document',
					'error_message' => 'Fields are required'
                );
                $this->load->view('import_question',$data);
			}
			else 
			{
				$data = array(
					'category' => $this->input->post('category')
				);
				
				$this->load->model('addcategory_model');
				
				$result = $this->addcategory_model->import_question($data);
				
				if($result != false) 
				{
					redirect('Admin/manage_question?msg=7');
				}
				else 
				{
					redirect('Admin/import_question?msg=5');
				}	
				
			}
		}
	}
	
	/* Below function has used for delete category */
	
	public function delete_category() 
	{
		$id = $_REQUEST['id'];
		
		$this->load->model('category_model');
		
		$category_result = $this->category_model->delete_category($id);
		
		if($category_result != false) 
		{
			redirect('Admin/manage_category?msg=3');
		}
		else 
		{
			redirect('Admin/manage_category?msg=3');
		}	
	}
	
	/* Below function has used for delete question */
	
	public function delete_question() 
	{
		$id = $_REQUEST['id'];
		
		$this->load->model('questions_model');
		
		$question_result = $this->questions_model->delete_question($id);
		
		if($question_result != false) 
		{
			redirect('Admin/manage_question?msg=3');
		}
		else 
		{
			redirect('Admin/manage_question?msg=3');
		}	
	}
	/* Below function has used for delete user */
	
	public function delete_user() 
	{
		$id = $_REQUEST['id'];
		
		$this->load->model('user_model');
		
		$user_result = $this->user_model->delete_users($id);
		
		if($user_result != false) 
		{
			redirect('Admin/manage_users?msg=3');
		}
		else 
		{
			redirect('Admin/manage_users?msg=3');
		}	
	}
	
	/* Below function has used for delete multiple categories */
	
	public function delete_selected_category() 
	{
		if(isset($_REQUEST))
		{
			$count1 = $_REQUEST['count'];
	
			for($i = 1;$i <= $count1;$i++)
			{
				$pid = "pid".$i;
				$chk = "chk".$i;
				if(isset($_REQUEST[$chk]))
				{
					$delid = $_REQUEST[$pid];

					$this->load->model('category_model');		
					
					$this->category_model->delete_category($delid);
				}
				
			}
			
			redirect('Admin/manage_category?msg=3');
		}
	}
	
	/* Below function has used for delete multiple questions */
	
	public function delete_selected_question() 
	{
		if(isset($_REQUEST))
		{
			$count1 = $_REQUEST['count'];
	
			for($i = 1;$i <= $count1;$i++)
			{
				$pid = "pid".$i;
				$chk = "chk".$i;
				if(isset($_REQUEST[$chk]))
				{
					$delid = $_REQUEST[$pid];

					$this->load->model('questions_model');
		
					$question_result = $this->questions_model->delete_question($delid);
				}
			}
			redirect('Admin/manage_question?msg=3');
		}
	}
	
	/* Below function has used for delete multiple users */
	
	public function delete_selected_users() 
	{
		if(isset($_REQUEST))
		{
			$count1 = $_REQUEST['count'];
	
			for($i = 1;$i <= $count1;$i++)
			{
				$pid = "pid".$i;
				$chk = "chk".$i;
				if(isset($_REQUEST[$chk]))
				{
					$delid = $_REQUEST[$pid];

					$this->load->model('user_model');
		
					$user_result = $this->user_model->delete_users($delid);
				}
			}
			redirect('Admin/manage_users?msg=3');
		}
	}
	
}
