<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Webservices extends CI_Controller 
{
	public function list_of_category() 
	{
		$this->load->model('category_model');
		
		$category_array = $this->category_model->category_list();
		
		$data = array(
			'category_array' => $category_array,
		);
		$this->load->view('list_of_category',$data);
	}

	public function list_of_questions() 
	{
		if(isset($_REQUEST['catid']) && $_REQUEST['catid'] != "")
		{
			$catid = $_REQUEST['catid'];
			
			$this->load->model('questions_model');
		
			$questions = $this->questions_model->question_list_catwise($catid);
			
			$data = array(
				'is_error' => '0',
				'questions_array' => $questions,
			);
			
			$this->load->view('list_of_questions',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'questions_array' => '',
			);
			
			$this->load->view('list_of_questions',$data);	
		}
	}	
	
	public function user_login() 
	{
		if(isset($_REQUEST['deviceid']) && $_REQUEST['deviceid'] != "")
		{
			$deviceid = $_REQUEST['deviceid'];
			
			$this->load->model('user_model');
		
			$user_data = $this->user_model->check_user_login($deviceid);
			
			$data = array(
				'is_error' => '0',
				'userdata_array' => $user_data,
			);
			
			$this->load->view('user_login',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'userdata_array' => '',
			);
			
			$this->load->view('user_login',$data);	
		}
	}

	public function register_user() 
	{
		if(isset($_REQUEST['deviceid']) && $_REQUEST['deviceid'] != "" && isset($_REQUEST['name']) && $_REQUEST['name'] != "")
		{
			$deviceid = $_REQUEST['deviceid'];
			$username = $_REQUEST['name'];
				
			$user_register_data = array(
				'deviceid' => $deviceid,
				'name' => $username
			);	
				
			$this->load->model('adduser_model');
		
			$userid = $this->adduser_model->add_user($user_register_data);
			
			$this->load->model('user_model');
		
			$userdata_array = $this->user_model->get_user_details($userid);
			
			$data = array(
				'is_error' => '0',
				'userdata_array' => $userdata_array,
			);
			
			$this->load->view('register_user',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'userdata_array' => '',
			);
			
			$this->load->view('register_user',$data);	
		}
	}

	public function get_user_info() 
	{
		if(isset($_REQUEST['deviceid']) && $_REQUEST['deviceid'] != "")
		{
			$deviceid = $_REQUEST['deviceid'];
			
			$this->load->model('user_model');
		
			$user_data = $this->user_model->check_user_login($deviceid);
			
			$data = array(
				'is_error' => '0',
				'userdata_array' => $user_data,
			);
			
			$this->load->view('get_user_info',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'userdata_array' => '',
			);
			
			$this->load->view('get_user_info',$data);	
		}
	}

	public function update_coins() 
	{
		if(isset($_REQUEST['deviceid']) && $_REQUEST['deviceid'] != "" && isset($_REQUEST['coins']) && $_REQUEST['coins'] != "")
		{
			$deviceid = $_REQUEST['deviceid'];
			$coins = $_REQUEST['coins'];
			
			$user_coin_data = array(
				'deviceid' => $deviceid,
				'coins' => $coins
			);	
			
			$this->load->model('adduser_model');
		
			$user_data = $this->adduser_model->update_coins_data($user_coin_data);
			
			$data = array(
				'is_error' => '0',
				'userdata_array' => $user_data,
			);
			
			$this->load->view('update_coins',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'userdata_array' => '',
			);
			
			$this->load->view('update_coins',$data);	
		}
	}

	public function update_user_face() 
	{
		if(isset($_REQUEST['deviceid']) && $_REQUEST['deviceid'] != "" && !empty($_FILES['face_picture']['name']))
		{
			$deviceid = $_REQUEST['deviceid'];
			
			$user_profile_data = array(
				'deviceid' => $deviceid
			);	
			
			$this->load->model('adduser_model');
		
			$user_data = $this->adduser_model->update_face_picture($user_profile_data);
			
			$data = array(
				'is_error' => '0',
				'userdata_array' => $user_data,
			);
			
			$this->load->view('update_user_face',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'userdata_array' => '',
			);
			
			$this->load->view('update_user_face',$data);	
		}
	}

	public function update_user_pic() 
	{
		if(isset($_REQUEST['deviceid']) && $_REQUEST['deviceid'] != "" && !empty($_FILES['profile_picture']['name']))
		{
			$deviceid = $_REQUEST['deviceid'];
			
			$user_profile_data = array(
				'deviceid' => $deviceid
			);	
			
			$this->load->model('adduser_model');
		
			$user_data = $this->adduser_model->update_profile_picture($user_profile_data);
			
			$data = array(
				'is_error' => '0',
				'userdata_array' => $user_data,
			);
			
			$this->load->view('update_user_pic',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'userdata_array' => '',
			);
			
			$this->load->view('update_user_pic',$data);	
		}
	}	
	
	public function set_game_result() 
	{
		if(isset($_REQUEST['deviceid']) && $_REQUEST['deviceid'] != "" && isset($_REQUEST['coins']) && $_REQUEST['coins'] != "" && isset($_REQUEST['total_corrent_answer']) && $_REQUEST['total_corrent_answer'] != "" && isset($_REQUEST['friend_id']) && $_REQUEST['friend_id'] != "" && isset($_REQUEST['phyched_counter']) && $_REQUEST['phyched_counter'] != "")
		{
			$deviceid = $_REQUEST['deviceid'];
			$coins = $_REQUEST['coins'];
			$total_corrent_answer = $_REQUEST['total_corrent_answer'];
			$friend_id = $_REQUEST['friend_id'];
			$phyched_counter = $_REQUEST['phyched_counter'];
			
			$phyched_data = array(
				'deviceid' => $deviceid,
				'coins' => $coins,
				'total_corrent_answer' => $total_corrent_answer,
				'friend_id' => $friend_id,
				'phyched_counter' => $phyched_counter
				
			);	
			
			$this->load->model('gameresult_model');
		
			$user_data = $this->gameresult_model->update_game_result($phyched_data);
			
			$data = array(
				'is_error' => '0',
				'userdata_array' => $user_data,
			);
			
			$this->load->view('set_game_result',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'userdata_array' => '',
			);
			
			$this->load->view('set_game_result',$data);	
		}
	}

	public function get_user_stats() 
	{
		if(isset($_REQUEST['deviceid']) && $_REQUEST['deviceid'] != "")
		{
			$deviceid = $_REQUEST['deviceid'];
			
			$this->load->model('gameresult_model');
		
			$user_data = $this->gameresult_model->get_game_status($deviceid);
			
			$data = array(
				'is_error' => '0',
				'game_result' => $user_data,
			);
			
			$this->load->view('get_user_stats',$data);	
		}
		else	
		{
			$data = array(
				'is_error' => '1',
				'game_result' => '',
			);
			
			$this->load->view('get_user_stats',$data);	
		}
	}	
}
